$NAME Phoenix :  - 

var Plg;

var vToDoLst;
var vMDTree;
var vListMDObjBlocks;
var vTemplates;
var c;
var mConnectString;

function JSTrim(vValue)
{
	return  vValue.replace(/(^\s*)|(\s*$)/g, "");
}

function Echo(text)
{
	Message(text, mNone);
}
/*
   
*/
function EnableDisableSubsystemsPanel()
{
	var PanelName = "";
	Windows.PanelVisible(PanelName) = !Windows.PanelVisible(PanelName);
}	

/*
     
*/
function GetToDoName(pID)
{
	var con = new ActiveXObject("ADODB.Connection");
	var Rs = new ActiveXObject("ADODB.RecordSet");
	con.ConnectionTimeOut=600;
	con.Open(mConnectString);
	Rs.ActiveConnection=con;
	strText = "select Name from ToDo where ID = "+pID;
	Rs.Open(strText, con);
	if ( (Rs.BOF == true) && (Rs.EOF == true))
	{
		return "     !";
	}
	Rs.MoveFirst();
	while(!Rs.eof)
	{
		mResult = JSTrim(Rs.Fields(0).Value);
		Rs.MoveNext();
	}
	Rs.Close();
	con.Close();
	return mResult;
}

/*
   XML 
*/
function ToDoSaveToFileXML()
{
	vToDoLst.SaveToFile("");
}

/* 
      
*/
function GetToDoIDFromString(pString)
{
	pString = JSTrim(pString);
	FInd = pString.indexOf("ToDoID(");
	if (FInd != -1)
	{
		return pString.substring(FInd+7,pString.indexOf(")",FInd+7));
		
	}
	else
		return -1;
}

/* 
   
*/
function ToDoCardShow()
{
	var vID = c.InputBox("  ", "", 0);
	if (vID != "")
		vToDoLst.OpenCard(vID);
}
/* 
  
*/
function OpenCurrentToDoCard()
{
	var Doc = c.GetTextDocIfOpened(0);
	if (Doc == null) 
		return;
	strDocToDo = GetToDoIDFromString(Doc.Range(Doc.SelStartLine, 0, Doc.SelEndLine, 100));
	if (strDocToDo != -1)
	{
		vR = vToDoLst.OpenCard(strDocToDo);
	}
}

/* 
        
*/
function GetAllToDoFromCurrentModule()
{
	var Doc = c.GetTextDocIfOpened(0);
	if (Doc == null) 
		return;
		
	list = "";
	for (var i=0; i<Doc.LineCount; i++)
	{
		strDocToDo = GetToDoIDFromString(Doc.Range(i, 0));
		if (strDocToDo != -1)
		{
			if (list.indexOf("("+strDocToDo+")") == -1)
				list += "("+ strDocToDo + ") " + GetToDoName(strDocToDo) + "\r\n";
		}
	}
	
	var vRes = CommonScripts.SelectValue(list, " ", "", true, true)
	if (!(vRes) == "")
	{
		var nEnd = vRes.indexOf(")")
		var nStr = vRes.substring(1,nEnd);
	}
	vR = vToDoLst.OpenCard(nStr);
}
/* 
  
*/
function CreateChildToDo()
{
	var vID = vToDoLst.GetSelectedToDoID();
	vToDoLst.CreateChild(vID);
	
}
/* 
   
*/
function SetMDObjBlock()
{
	var vClass = vMDTree.GetNodeClass();
	if (vClass == -1)
		return;
	
	if (vMDTree.GetCurrentMDObj() != 0)
	{
		var	vObj = vMDTree.GetCurrentMDObj();
		vListMDObjBlocks.SetBlock(vObj.ID);
	}
}

/* 
   
*/
function GoToNextPage()
{
	 SendCommand(32857)
}

/* 
   
*/
function GoToSSPage()
{
	Plg.GoToSheet("subsystems")
}

/* 
    
*/
function TemplateCardShow()
{
	vID = c.InputBox(" ","",0);
	if (vID != "")
		vTemplates.OpenCardByID(vID);
}
/* 
    
*/
function GetTextFromClpbrd()
{
	vTemplates.GetTextFromClipboard();
}
/* 
    
*/
function SetTextToClpbrd()
{
	vTemplates.SetTextToClipboard(0);
}

/* 
    SQL 
*/
function ShowSQLConnectionString()
{
	Echo(Plg.GetSQLConnectionString());
}

/* 
      
*/
function MetadataTreeShowNameSynonym()
{
	if (vMDTree.GetTypeViewIndex() != 1)
	{
		vMDTree.SetTypeViewIndex(1);
		vMDTree.Fill();
	}
}
/* 
     
*/
function MetadataTreeShowName()
{
	if (vMDTree.GetTypeViewIndex() != 0)
	{
		vMDTree.SetTypeViewIndex(0);
		vMDTree.Fill();
	}
}

//  
function InitDim(V)
{
	vMDTree = Plg.GetMDTree();
	vToDoLst = Plg.GetToDoList();
	vListMDObjBlocks = Plg.GetListMDObjBlocks();
	vTemplates = Plg.GetTemplates();

	mConnectString = Plg.GetDataConnectionString();
}


//    
function Init(_) //  ,      
{    
    try {
       
       Plg	= Plugins("");
       InitDim(1);
       
	c = null;
        if (!(c = new ActiveXObject("OpenConf.CommonServices"))) 
	{
            throw(true); //  
        }        
        c.SetConfig(Configurator);
        SelfScript.AddNamedItem("CommonScripts", c, false);
	
	
    }
    catch (e) {
        Message("    OpenConf.CommonServices", mRedErr);    
        Message(" " & SelfScript.Name & "  ", mInformation);
        Scripts.UnLoad(SelfScript.Name);
    }
}

Init(1); //      